%Plant = tf( {[1 1] [1 0] ; [1] [1 2]} , {[1 2 2] [1 2 2] ; [1 2 2] [1 2 2]});
%Plant = tf( {[-1 -1000] [500 0] ; [2000] [1 2000]} ,{ 100*[1 2 2]  100*[1 2 2] ;  100*[1 2 2]  100*[1 2 2]});


A=[-2 -2 0 0; 1 0 0 0;0 0 -2 -2; 0 0 1 0];
B=[1 0 0 0;0 0 1 0]';
C=[-0.01 -10 5 0; 0 20 0.01 20];
Plant=ss(A,B,C,zeros(2,2));

% sys=ss(Plant);
% A=sys.a;
% B=sys.b;
% C=sys.c;

figure(1)
step(Plant);
title('Coupled Plant Step Responses')

%=======Geometric Input-Output Decoupling
disp('C_1 B = ');
C(1,:)*B
disp('Thus, d_1 = 0');
disp('C_2 B = ');
C(2,:)*B
disp('Thus, d_2 = 0');
Q = [C(1,:)*B;C(2,:)*B]

P = [C(1,:)*A;C(2,:)*A]

%======Compute decoupled system=====
Ac = A - B*inv(Q)*P; %close loop A
Bc = B*inv(Q);
CLP = ss(Ac,Bc,C,zeros(2,2));

figure(2)
step(CLP);
title('Decoupled Plant Step Responses')

%======Controller design (you can vary the cutoff frequency wc below
wc=100; % Cut-off frequency
K = wc*eye(2);
L = CLP*K;
Unit=eye(2);
T=feedback(L,Unit);
S=Unit-T;

figure(3)
step(T,10/wc);
title('Close Loop Plant Step Responses')

figure(4)
step(S,10/wc);
title('Close Loop Plant Tracking Error')


